osg::AttributeDispatchers Class Reference

`#include <AttributeDispatchers>`

Inheritance diagram for osg::AttributeDispatchers:

## Public Member Functions

| AttributeDispatchers ()
| ~AttributeDispatchers ()
void | setState (osg::State *state)
void | reset ()
void | setUseVertexAttribAlias (bool flag)
bool | getUseVertexAttribAlias () const
void | activateColorArray (osg::Array *array)
void | activateNormalArray (osg::Array *array)
void | activateSecondaryColorArray (osg::Array *array)
void | activateFogCoordArray (osg::Array *array)
void | activateVertexAttribArray (unsigned int unit, osg::Array *array)
AttributeDispatch * | normalDispatcher (Array *array)
AttributeDispatch * | colorDispatcher (Array *array)
AttributeDispatch * | secondaryColorDispatcher (Array *array)
AttributeDispatch * | fogCoordDispatcher (Array *array)
AttributeDispatch * | vertexAttribDispatcher (unsigned int unit, Array *array)
void | dispatch (unsigned int index)
bool | active () const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::vector< AttributeDispatchMap * > | AttributeDispatchMapList
typedef std::vector< AttributeDispatch * > | AttributeDispatchList

## Protected Member Functions

void | init ()
void | assignTexCoordDispatchers (unsigned int unit)
void | assignVertexAttribDispatchers (unsigned int unit)
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

bool | _initialized
State * | _state
AttributeDispatchMap * | _normalDispatchers
AttributeDispatchMap * | _colorDispatchers
AttributeDispatchMap * | _secondaryColorDispatchers
AttributeDispatchMap * | _fogCoordDispatchers
AttributeDispatchMapList | _vertexAttribDispatchers
AttributeDispatchList | _activeDispatchList
bool | _useVertexAttribAlias
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Helper class for managing the dispatch to OpenGL of various attribute arrays such as stored in osg::Geometry.

## Member Typedef Documentation

## AttributeDispatchList

typedef std::vector<AttributeDispatch*> osg::AttributeDispatchers::AttributeDispatchList

protected

## AttributeDispatchMapList

typedef std::vector<AttributeDispatchMap*> osg::AttributeDispatchers::AttributeDispatchMapList

protected

## Constructor & Destructor Documentation

## AttributeDispatchers()

osg::AttributeDispatchers::AttributeDispatchers | ( |  | ) |

## ~AttributeDispatchers()

osg::AttributeDispatchers::~AttributeDispatchers | ( |  | ) |

## Member Function Documentation

## activateColorArray()

void osg::AttributeDispatchers::activateColorArray | ( | osg::Array * | array | ) |

inline

References colorDispatcher(), and DISPATCH_OR_ACTIVATE.

## activateFogCoordArray()

void osg::AttributeDispatchers::activateFogCoordArray | ( | osg::Array * | array | ) |

inline

References DISPATCH_OR_ACTIVATE, and fogCoordDispatcher().

## activateNormalArray()

void osg::AttributeDispatchers::activateNormalArray | ( | osg::Array * | array | ) |

inline

References DISPATCH_OR_ACTIVATE, and normalDispatcher().

## activateSecondaryColorArray()

void osg::AttributeDispatchers::activateSecondaryColorArray | ( | osg::Array * | array | ) |

inline

References DISPATCH_OR_ACTIVATE, and secondaryColorDispatcher().

## activateVertexAttribArray()

void osg::AttributeDispatchers::activateVertexAttribArray | ( | unsigned int | unit,
|  | osg::Array * | array )

inline

References DISPATCH_OR_ACTIVATE, and vertexAttribDispatcher().

## active()

bool osg::AttributeDispatchers::active | ( |  | ) | const

inline

References _activeDispatchList.

## assignTexCoordDispatchers()

void osg::AttributeDispatchers::assignTexCoordDispatchers | ( | unsigned int | unit | ) |

protected

## assignVertexAttribDispatchers()

void osg::AttributeDispatchers::assignVertexAttribDispatchers | ( | unsigned int | unit | ) |

protected

## colorDispatcher()

AttributeDispatch * osg::AttributeDispatchers::colorDispatcher | ( | Array * | array | ) |

Referenced by activateColorArray().

## dispatch()

void osg::AttributeDispatchers::dispatch | ( | unsigned int | index | ) |

inline

References _activeDispatchList.

## fogCoordDispatcher()

AttributeDispatch * osg::AttributeDispatchers::fogCoordDispatcher | ( | Array * | array | ) |

Referenced by activateFogCoordArray().

## getUseVertexAttribAlias()

bool osg::AttributeDispatchers::getUseVertexAttribAlias | ( |  | ) | const

inline

References _useVertexAttribAlias.

## init()

void osg::AttributeDispatchers::init | ( |  | ) |

protected

## normalDispatcher()

AttributeDispatch * osg::AttributeDispatchers::normalDispatcher | ( | Array * | array | ) |

Referenced by activateNormalArray().

## reset()

void osg::AttributeDispatchers::reset | ( |  | ) |

## secondaryColorDispatcher()

AttributeDispatch * osg::AttributeDispatchers::secondaryColorDispatcher | ( | Array * | array | ) |

Referenced by activateSecondaryColorArray().

## setState()

void osg::AttributeDispatchers::setState | ( | osg::State * | state | ) |

## setUseVertexAttribAlias()

void osg::AttributeDispatchers::setUseVertexAttribAlias | ( | bool | flag | ) |

inline

References _useVertexAttribAlias.

## vertexAttribDispatcher()

AttributeDispatch * osg::AttributeDispatchers::vertexAttribDispatcher | ( | unsigned int | unit,
|  | Array * | array )

Referenced by activateVertexAttribArray().

## Member Data Documentation

## _activeDispatchList

AttributeDispatchList osg::AttributeDispatchers::_activeDispatchList

protected

Referenced by active(), and dispatch().

## _colorDispatchers

AttributeDispatchMap* osg::AttributeDispatchers::_colorDispatchers

protected

## _fogCoordDispatchers

AttributeDispatchMap* osg::AttributeDispatchers::_fogCoordDispatchers

protected

## _initialized

bool osg::AttributeDispatchers::_initialized

protected

## _normalDispatchers

AttributeDispatchMap* osg::AttributeDispatchers::_normalDispatchers

protected

## _secondaryColorDispatchers

AttributeDispatchMap* osg::AttributeDispatchers::_secondaryColorDispatchers

protected

## _state

State* osg::AttributeDispatchers::_state

protected

## _useVertexAttribAlias

bool osg::AttributeDispatchers::_useVertexAttribAlias

protected

Referenced by getUseVertexAttribAlias(), and setUseVertexAttribAlias().

## _vertexAttribDispatchers

AttributeDispatchMapList osg::AttributeDispatchers::_vertexAttribDispatchers

protected

The documentation for this class was generated from the following file:

- AttributeDispatchers